## razer 1.1.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(razer-drivers)

set(SOURCES
        driver/razermouse_driver.c
        driver/razerfirefly_driver.c
        driver/razerkbd_driver.c
        driver/razercommon.c
        driver/razerchromacommon.c
        )

set(HEADERS
        driver/razermouse_driver.h
        driver/razerfirefly_driver.h
        driver/razerkbd_driver.h
        driver/razercommon.h
        driver/razerchromacommon.h
        )

set(TARGET_VARS
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
        SOURCES ${HEADERS} ${SOURCES}
)

execute_process(COMMAND uname -r
        OUTPUT_VARIABLE INSTALLED_KERNEL
        OUTPUT_STRIP_TRAILING_WHITESPACE
)
set(LINUX_KERNEL_PATH /usr/lib/modules/${INSTALLED_KERNEL})
include_directories(${LINUX_KERNEL_PATH}/build/include
    ${LINUX_KERNEL_PATH}/build/arch/x86/include
)

# Build all target
add_custom_target(All # all is reserved
        COMMAND make all
        ${TARGET_VARS}
)
add_custom_target(build-lp-all
        COMMAND make lp_all
        ${TARGET_VARS}
)

# Driver compilation
add_custom_target(driver
        COMMAND make driver
        ${TARGET_VARS}
)
add_custom_target(driver-verbose
        COMMAND make driver_verbose
        ${TARGET_VARS}
)
add_custom_target(driver-clean
        COMMAND make driver_clean
        ${TARGET_VARS}
)
# Install kernel modules and then update module dependencies
add_custom_target(driver-install
        COMMAND make driver_install
        ${TARGET_VARS}
)
# Remove kernel modules
add_custom_target(driver-uninstall
        COMMAND make driver_uninstall
        ${TARGET_VARS}
)

# Launchpad hacks
add_custom_target(lp-driver
        COMMAND make lp_driver
        ${TARGET_VARS}
)
add_custom_target(lp-driver-clean
        COMMAND make lp_driver_clean
        ${TARGET_VARS}
)

# Razer Daemon
add_custom_target(daemon-install
        COMMAND make daemon_install
        ${TARGET_VARS}
)
add_custom_target(daemon-uninstall
        COMMAND make daemon_uninstall
        ${TARGET_VARS}
)

# Python Library
add_custom_target(python-library-install
        COMMAND make python_library_install
        ${TARGET_VARS}
)
add_custom_target(python-library-uninstall
        COMMAND make python_library_uninstall
        ${TARGET_VARS}
)

# Clean target
add_custom_target(Clean # clean is reserved
        COMMAND make clean
        ${TARGET_VARS}
)

add_custom_target(setup-dkms
        COMMAND make setup_dkms
        ${TARGET_VARS}
)

add_custom_target(udev-install
        COMMAND make udev_install
        ${TARGET_VARS}
)
add_custom_target(udev-uninstall
        COMMAND make udev_uninstall
        ${TARGET_VARS}
)

# Install for Ubuntu
add_custom_target(ubuntu-install
        COMMAND make ubuntu_install
        ${TARGET_VARS}
)

add_custom_target(Install # install is reserved
        COMMAND make install
        ${TARGET_VARS}
)
add_custom_target(Uninstall # uninstall is reserved
        COMMAND make uninstall
        ${TARGET_VARS}
)

add_executable(FakeTarget ${HEADERS} ${SOURCES}) # fake target so kernel includes are found for autocompletion

target_compile_definitions(FakeTarget PUBLIC __KERNEL__=1)

=== daemon/Makefile ===
DESTDIR?=/
PREFIX?=/usr

purge_pycache:
	@find -name '__pycache__' | xargs rm -rf

service:
	@sed "s|##PREFIX##|$(PREFIX)|" resources/org.razer.service.in > org.razer.service
	@sed "s|##PREFIX##|$(PREFIX)|" resources/razer-daemon.systemd.service.in > razer-daemon.service

install-resources: service
	@install -m 644 -D -v resources/razer.conf $(DESTDIR)$(PREFIX)/share/openrazer/razer.conf.example
	@install -m 755 -D -v run_razer_daemon.py $(DESTDIR)$(PREFIX)/bin/razer-daemon
	@install -m 644 -D -v org.razer.service $(DESTDIR)$(PREFIX)/share/dbus-1/services/org.razer.service
	@install -m 644 -D -v razer-daemon.service $(DESTDIR)$(PREFIX)/lib/systemd/user/razer-daemon.service

install: purge_pycache manpages install-resources
	python3 setup.py install --prefix=$(PREFIX) --root=$(DESTDIR)

ubuntu_install: purge_pycache manpages install-resources
	python3 setup.py install --prefix=$(PREFIX) --root=$(DESTDIR) --no-compile

manpages:
	@install -m 644 -D -v resources/man/razer.conf.5 $(DESTDIR)$(PREFIX)/share/man/man5/razer.conf.5
	@gzip $(DESTDIR)$(PREFIX)/share/man/man5/razer.conf.5
	@install -m 644 -D -v resources/man/razer-daemon.8 $(DESTDIR)$(PREFIX)/share/man/man8/razer-daemon.8
	@gzip $(DESTDIR)$(PREFIX)/share/man/man8/razer-daemon.8

manpages_uninstall:
	@rm -f $(DESTDIR)$(PREFIX)/share/man/man5/razer.conf.5.gz
	@rm -f $(DESTDIR)$(PREFIX)/share/man/man8/razer-daemon.8.gz

uninstall: manpages_uninstall
	$(eval DAEMONPATH := $(shell find $(DESTDIR)$(PREFIX)/lib/python3* -maxdepth 2 -name "razer_daemon"))
	$(eval EGGPATH := $(shell readlink -f $(DAEMONPATH)-*.egg-info/)) # shows an error when it's not already installed (maybe use some if condition)
	@rm -rf -v $(DAEMONPATH)
	@rm -rf -v $(EGGPATH)
	@rm -rf -v $(DESTDIR)$(PREFIX)/share/openrazer
	@rm -f -v $(DESTDIR)$(PREFIX)/bin/razer-daemon

=== debian/changelog ===
razer (1.1.15-0ubuntu1) xenial; urgency=high
  * Added Device - Razer Orochi 2013
  * Added Device - Razer Kraken 7.1 Classic
  * Added Device - Razer Tartarus
  * Added startlight to pylib
  * Added DBus endpoint to list supported devices
  * Fixed some Razer image resource urls
  * Added replaces in control file to purge razer-chroma-drivers

 -- Terry Cain <terry@terrys-home.co.uk>  Sat, 30 Jul 2017 16:12:00 +0000

razer (1.1.14-0ubuntu1) xenial; urgency=high
  * Added Device - Razer DeathStalker Expert
  * Added Device - Razer Orbweaver Chroma
  * Added Device - Razer Orochi 2011
  * Fixed bug (in daemon code) where serial is blank or 'Default String'
  * Fixed bug where battery notifier will crash if started before notification daemon
  * Replaced XDG Autostart with SystemD dbus unit, will autostart when org.razer is accessed
  * Updated man pages
  * Nerf'd make install
  * Moved data dir to .local
  * Updated pid check to allow for running as 1 daemon per user
  * Added battery endpoints to Mamaba2012
  * z3ntu reformatted all the driver files

 -- Terry Cain <terry@terrys-home.co.uk>  Sat, 1 Jul 2017 17:33:00 +0000

razer (1.1.13-0ubuntu1) xenial; urgency=high

  * Added Device - Razer Naga Hex (Red)
  * Fixed bug where udev was matching whole tree not just device
  * Fixed bug in 1byte dpi logic for old devices
  * Renamed razer-service back to razer-daemon
  * Added more example scripts
  * Changed default serials on fake driver configs

 -- Terry Cain <terry@terrys-home.co.uk>  Sun, 11 Jun 2017 17:24:00 +0000

razer (1.1.12-0ubuntu1) xenial; urgency=high

  * Changed README
  * Added in missing DPI for DeathAdder Elite

 -- Terry Cain <terry@terrys-home.co.uk>  Wed, 3 May 2017 20:04:00 +0000

razer (1.1.11-0ubuntu1) xenial; urgency=low

  * Added Device - Overwatch Razer BlackWidow Chroma
  * Added Device - Razer Naga 2014
  * Fixed Bug where serial wasnt reported during device add, causing DBus to die a horrible death
  * Fixed inconsistencies where some firmware versions has newlines when interacting with the driver directly
  * Added some more mutex's in mouse driver
  * Swapped around mice and keyboard block in udev as udev was doing the dodgy
  * Added Naga 2014 to fake driver, fixed some other issues there
  * Fixed poll_rate constant which was overlooked when numbers changed
  * Added .backlight.active properties to mice in pylib

 -- Terry Cain <terry@terrys-home.co.uk>  Mon, 17 Apr 2017 11:21:00 +0000

razer (1.1.10-0ubuntu1) xenial; urgency=low

  * Fixed bug with Razer Blade QHD Lighting
  * Added Device - Razer Blade (Late 2016)
  * Added Device - Razer Mamba 2012 (Wired)
  * Added Device - Razer Mamba 2012 (Wireless)
  * Added Device - Razer Taipan
  * Added Device - Razer Nostromo
  * Now a DBus method to trigger reactive on firefly
  * Added a maxDPI() method to DBus and the python library
  * Fixed limited with some Blade RGB payloads
  * Fixed some crash conditions
  * Slowly prepping driver for some windows ifdefs so that it can compile on windows easily
  * Added raw_event function to mice that detects buttons when in device mode (doesnt work yet, proper code is in other branch)
  * Started adding mutex's to mice
  * Added macros globally in pylib
  * Added firefly class to pylib

 -- Terry Cain <terry@terrys-home.co.uk>  Sat, 15 Apr 2017 21:54:00 +0000

razer (1.1.9-0ubuntu1) xenial; urgency=low

  * Added options to daemon for restarting / stopping using the dameon script
  * Added more permission checks so solve some more issues.
  * Added Device - Razer Core
  * Added Device - Razer Naga Hex
  * Added Device - Razer BlackWidow Classic (Alternate)
  * Added Device - Razer BlackWidow Chroma V2
  * Added in more urls
  * Added custom mode to kraken
  * Added config option to stop battery notifications
  * Fixed bug when receiving multiple of the same screensaver events
  * Major changes to man pages

 -- Terry Cain <terry@terrys-home.co.uk>  Sat, 04 Mar 2017 14:47:00 +0000

razer (1.1.8-0ubuntu1) xenial; urgency=low

  * Removed driver_verbose make target and made the driver target be verbose
  * Added Device - Razer Ornata
  * Replaced screensaver thread with some logic to monitor DBus signals
  * Daemon now assignes the other interfaces of the device to the main device object
  * Fixed typo in Ornata Chroma daemon entry
  * Added poll rate to Mamba Chroma
  * Driver now has capability to block SuperKey, Alt+Tab, Alt+F4 for Game Mode

 -- Terry Cain <terry@terrys-home.co.uk>  Sat, 21 Jan 2017 21:56:00 +0000

razer (1.1.7-0ubuntu1) xenial; urgency=low

  * Added Device - Razer Orbweaver
  * Fixed error in dependancy name
  * Fixed error from merging

 -- Terry Cain <terry@terrys-home.co.uk>  Tue, 17 Jan 2017 19:29:00 +0000

razer (1.1.6-0ubuntu1) xenial; urgency=low

  * Fixed bug in Makefile where drivers wernt being copied over
  * Added Device - Razer DeathStalker Chroma
  * Added Device - Razer BlackWidow X Ultimate
  * Added Device - Razer Ouroboros 2012
  * Added Device - Razer DeathAdder Chroma
  * Added Device - Razer Diamonback Chroma
  * Added device add and device remove signals to the daemon
  * Overhaul'd the daemons device add/remove logic so that it actually works now, and works well
  * Added dict's to devices so that the python library can get links to Razer Store and device images
  * Added Razer BlackWidow 2012 and BlackWidow Classic to daemon
  * Fixed matrix limits on firefly and mug
  * Commented out evil log line that spams
  * Fixed package dependancy issue when on KDE
  * Fixed case issue in udev rules
  * Added config for kraken v1/2 and mug for device emulation

 -- Terry Cain <terry@terrys-home.co.uk>  Mon, 16 Jan 2017 21:11:00 +0000

razer (1.1.5-0ubuntu1) xenial; urgency=low

  * Big changes to overall build structure to facilitate proper RPM specfile building
  * Added Device - Razer Anansi
  * Added Device - Razer Naga Hex V2
  * Added Device - Razer DeathAdder Elite
  * Added Device - Razer Kraken 7.1 Chroma


=== debian/control ===
Source: razer
Section: misc
Priority: optional
Maintainer: Terry Cain <terry@terrys-home.co.uk>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 8.0.0),
               python3,
               python3-setuptools
Homepage: https://terrycain.github.io/razer-drivers/
Vcs-Git: git://git@github.com:terrycain/razer-drivers.git
Vcs-Browser: https://github.com/terrycain/razer-drivers/

Package: razer-kernel-modules-dkms
Section: kernel
Architecture: amd64 i386
Depends: dkms,
         udev,
         ${misc:Depends}
Replaces: razer-chroma-driver
Description: Razer Peripheral Drivers
 A keyboard driver, a mouse driver and a mousemat driver
 for Razer devices, plus support for Razer Blade devices.

Package: razer-daemon
Section: misc
Architecture: amd64 i386
Depends: razer-kernel-modules-dkms,
         python3,
         python3-dbus,
         python3-gi,
         python3-pyudev,
         python3-evdev,
         python3-setproctitle,
         python3-notify2,
         gir1.2-gtk-3.0,
         xautomation,
         xdotool,
         dbus-user-session
Recommends: python3-razer
Description: Razer Device Daemon
 A user-space daemon used to interface with the driver.
 It auto-starts in the XDG directory and handles syncing
 across devices.

Package: python3-razer
Section: misc
Architecture: all
Depends: python3,
         python3-dbus,
         python3-gi,
         python3-numpy
Description: Razer Python Library
 Contains a client for interacting with the Razer daemon.

Package: razer-doc
Section: doc
Architecture: all
Description: Documentation and examples for the Razer Tools
 Scripts on how to interact with the daemon and the driver.

Package: openrazer-meta
Section: misc
Architecture: all
Depends: python3-razer,
         razer-daemon,
         razer-kernel-modules-dkms
Description: Meta package for openrazer

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

BUILD_DIR=$(CURDIR)/build
DEB_DESTDIR=$(CURDIR)/debian/tmp/

override_dh_auto_install:
	make ubuntu_install DESTDIR=$(DEB_DESTDIR)

override_dh_auto_build:
	dh_auto_build -- lp_all

override_dh_auto_clean:
	$(MAKE) lp_driver_clean

%:
	dh $@ --with-python3
